# wxCloseEvent Class Reference
[Events]

`#include <wx/event.h>`

Inheritance diagram for wxCloseEvent:
[legend]

## Detailed Description

This event class contains information about window and session close events.

The handler function for EVT_CLOSE is called when the user has tried to close a a frame or dialog box using the window manager (X) or system menu (Windows). It can also be invoked by the application itself programmatically, for example by calling the wxWindow::Close function.

You should check whether the application is forcing the deletion of the window using wxCloseEvent::CanVeto. If this is false, you must destroy the window using wxWindow::Destroy.

If the return value is true, it is up to you whether you respond by destroying the window.

If you don't destroy the window, you should call wxCloseEvent::Veto to let the calling code know that you did not destroy the window. This allows the wxWindow::Close function to return true or false depending on whether the close instruction was honoured or not.

Example of a wxCloseEvent handler:

            void MyFrame::OnClose(wxCloseEvent& event)
            {
                if ( event.CanVeto() && m_bFileNotSaved )
                {
                    if ( wxMessageBox("The file has not been saved... continue closing?",
                                      "Please confirm",
                                      wxICON_QUESTION | wxYES_NO) != wxYES )
                    {
                        event.Veto();
                        return;
                    }
                }

                Destroy();  // you may also do:  event.Skip();
                            // since the default event handler does call Destroy(), too
            }

The EVT_END_SESSION event is slightly different as it is sent by the system when the user session is ending (e.g. because of log out or shutdown) and so all windows are being forcefully closed. At least under MSW, after the handler for this event is executed the program is simply killed by the system. Because of this, the default handler for this event provided by wxWidgets calls all the usual cleanup code (including wxApp::OnExit()) so that it could still be executed and exit()s the process itself, without waiting for being killed. If this behaviour is for some reason undesirable, make sure that you define a handler for this event in your wxApp-derived class and do not call `event.Skip()` in it (but be aware that the system will still kill your application).

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxCloseEvent& event)
Event macros:

- EVT_CLOSE(func):
  Process a `wxEVT_CLOSE_WINDOW` command event, supplying the member function. This event applies to wxFrame and wxDialog classes.
- EVT_QUERY_END_SESSION(func):
  Process a `wxEVT_QUERY_END_SESSION` session event, supplying the member function. This event can be handled in wxApp-derived class only.
- EVT_END_SESSION(func):
  Process a `wxEVT_END_SESSION` session event, supplying the member function. This event can be handled in wxApp-derived class only.

##

Library: wxCore

Category: Events

See also:
  wxWindow::Close, Window Deletion

## Public Member Functions
| wxCloseEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor.
bool | CanVeto () const
| Returns true if you can veto a system shutdown or a window close event.
bool | GetLoggingOff () const
| Returns true if the user is just logging off or false if the system is shutting down.
void | SetCanVeto (bool canVeto)
| Sets the 'can veto' flag.
void | SetLoggingOff (bool loggingOff)
| Sets the 'logging off' flag.
void | Veto (bool veto=true)
| Call this from your event handler to veto a system shutdown or to signal to the calling application that a window close did not happen.

List of all members.

## Constructor & Destructor Documentation

wxCloseEvent::wxCloseEvent | ( | wxEventType | commandEventType = `wxEVT_NULL`,
|  | int | id = `0` |
| ) |  |  |

Constructor.

## Member Function Documentation

bool wxCloseEvent::CanVeto | ( |  | ) | const

Returns true if you can veto a system shutdown or a window close event.

Vetoing a window close event is not possible if the calling code wishes to force the application to exit, and so this function must be called to check this.

bool wxCloseEvent::GetLoggingOff | ( |  | ) | const

Returns true if the user is just logging off or false if the system is shutting down.

This method can only be called for end session and query end session events, it doesn't make sense for close window event.

void wxCloseEvent::SetCanVeto | ( | bool | canVeto | ) |

Sets the 'can veto' flag.

void wxCloseEvent::SetLoggingOff | ( | bool | loggingOff | ) |

Sets the 'logging off' flag.

void wxCloseEvent::Veto | ( | bool | veto = `true` | ) |

Call this from your event handler to veto a system shutdown or to signal to the calling application that a window close did not happen.

You can only veto a shutdown if CanVeto() returns true.

|  | [ top ]